 /****************************************************************************
**      DISCLAIMER
**
**   Novell, Inc. makes no representations or warranties with respect to
**   any NetWare software, and specifically disclaims any express or
**   implied warranties of merchantability, title, or fitness for a
**   particular purpose.
**
**   Distribution of any NetWare software is forbidden without the
**   express written consent of Novell, Inc.  Further, Novell reserves
**   the right to discontinue distribution of any NetWare software.
**
**   Novell is not responsible for lost profits or revenue, loss of use
**   of the software, loss of data, costs of re-creating lost data, the
**   cost of any substitute equipment or program, or claims by any party
**   other than you.  Novell strongly recommends a backup be made before
**   any software is installed.   Technical support for this software
**   may be provided at the discretion of Novell.
****************************************************************************
**   Include headers, macros, function prototypes, etc.
*/

	/*------------------------------------------------------------------
	**   WINDOWS
	*/
	#define NWWIN
	#include <windows.h>
	#include <windowsx.h>
	#include <stdio.h>
	#include <string.h>

	#define MY_START   200

	#define MBox(a, b, c, d) MessageBox(a, b, c, d)

/*------------------------------------------------------------------
**   NetWare
*/
	#include <nwcalls.h>
	#include <nwnet.h>

	 #undef SOCKET_NOT_OPEN
	 #undef SOCKET_ALREADY_OPEN
	 #undef MIN
	 #undef FAILURE

	#include <nwclxcon.h>
	#include <nwipxspx.h>
	#include <diag.h>

/*---------------------------------------------------------------------
** Prototypes
*/

void DoDiagnostics(HWND hwnd);

LRESULT CALLBACK WndProc( HWND hWnd, UINT mess, WPARAM  wParam, LPARAM lParam ); void WndProc_OnPaint(HWND hWnd); void WndProc_OnClose(HWND hWnd); void WndProc_OnDestroy(HWND hWnd); void WndProc_OnCommand(HWND hwnd,int wParam, HWND lParam, UINT codeNotify);
BOOL WndProc_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct);

/************************************************************************
** Main windows program
*/ int PASCAL WinMain (HANDLE hInstance,HANDLE hPrevInstance,LPSTR lpszCmdLine, int nCmdShow)
{
	static char   szAppName[] = "WINTIME";
	HWND      hwnd;
	MSG       msg;
	WNDCLASS  wndclass;


	if (hPrevInstance)
	return 1;

	wndclass.style            = CS_HREDRAW | CS_VREDRAW;
	wndclass.lpfnWndProc      = (WNDPROC)WndProc;
	wndclass.cbClsExtra       = 0;
	wndclass.cbWndExtra       = 0;
	wndclass.hInstance        = hInstance;
	wndclass.hIcon            = NULL;
	wndclass.hCursor          = LoadCursor (NULL, IDC_ARROW);
	wndclass.hbrBackground    = GetStockObject(GRAY_BRUSH);
	wndclass.lpszMenuName     = NULL;
	wndclass.lpszClassName    = szAppName;

	RegisterClass (&wndclass);

	hwnd = CreateWindow(szAppName, "Basic C Windows Program",
	  WS_OVERLAPPEDWINDOW, 0, 0,
	  CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL,
	  hInstance, NULL);

	ShowWindow (hwnd, nCmdShow);
	UpdateWindow (hwnd);

	while ( GetMessage(&msg, NULL, 0, 0) )
	{
	TranslateMessage(&msg);
	DispatchMessage(&msg);
	}

	return msg.wParam;

}

/***********************************************************************
** The window function for handling messages sent to this application
*/
//long FAR PASCAL WndProc (HWND hwnd, WORD message, WORD wParam, LONG lParam)
LRESULT CALLBACK WndProc(HWND hwnd, UINT message, WPARAM  wParam, LPARAM lParam)
{
	static HANDLE   hInstance;

	/*-------------------------------------------------------------------
	** Message Crackers
	*/
	switch (message){
	HANDLE_MSG(hwnd,WM_COMMAND,WndProc_OnCommand);
	HANDLE_MSG(hwnd,WM_DESTROY,WndProc_OnDestroy);
	HANDLE_MSG(hwnd,WM_CLOSE,WndProc_OnClose);
	HANDLE_MSG(hwnd,WM_PAINT,WndProc_OnPaint);
	HANDLE_MSG(hwnd,WM_CREATE,WndProc_OnCreate);
	}
	return DefWindowProc(hwnd, message, wParam, lParam);
}


/***********************************************************************
**WM_PAINT routine
*/ void WndProc_OnPaint(HWND hwnd)
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rect;

	hdc=BeginPaint(hwnd,&ps);
	GetClientRect(hwnd,&rect);
	DrawText(hdc,"NetWare API Examples",-1,&rect,DT_SINGLELINE|DT_CENTER|DT_VCENTER);
	EndPaint(hwnd,&ps);
}

/***********************************************************************
** WM_CLOSE routine
*/ void WndProc_OnClose(HWND hwnd)
{
	if(MessageBox(hwnd,"Are you sure you want to exit?","Exit Window",
	MB_ICONQUESTION | MB_OKCANCEL)==IDOK)
	DestroyWindow(hwnd);
}

/***********************************************************************
**WM_DESTROY routine
*/ void WndProc_OnDestroy(HWND hwnd)
{
	PostQuitMessage( 0 );
}
/***********************************************************************
**WM_COMMAND routine
*/ void WndProc_OnCommand(HWND hwnd,int wParam, HWND lParam, UINT codeNotify)
{
  nuint	j;

	switch (wParam)
	{
	case MY_START:
	do
	{
	j=MBox( hwnd,
			  (LPSTR)"Ready to Start?",
			  (LPSTR)"", MB_YESNO | MB_ICONQUESTION);
	if(j==IDYES)
	{
					DoDiagnostics(hwnd);
	}

	j=MBox( hwnd,
			  (LPSTR)"All Done?",
			  (LPSTR)"", MB_YESNO | MB_ICONQUESTION);
	} while(j==IDNO);
	break;

	default:
	break;
	}
	return;
}

/***********************************************************************
**WM_CREATE routine
*/
BOOL WndProc_OnCreate(HWND hwnd, CREATESTRUCT FAR* lpCreateStruct)
{
	 PostMessage(hwnd, WM_COMMAND, MY_START, 0L);
	 return 1;
}


/***********************************************************************
** DoDiagnostics routine
*/

void DoDiagnostics(HWND hwnd)
{
	NWCCODE        				ccode;
	nuint								idx, cnt;
	char	       					string[256];
	NWCONN_HANDLE					conn;
	NWCONN_NUM     				i;
	NWINET_ADDR						addr;
	BeginDiagnosticStruct		destination;
	WORD								diagSocket;
	BYTE           				componentList[54];
	WORD           				connectionID;
	BYTE								offset;
	AllResponseData    	      intvptr;


	DriverConfigurationStruct  SHELLdata;

	ccode=NWCallsInit(NULL, NULL);
	cnt = sprintf(string, "NWCallsInit returned:  %X\n", ccode);

	ccode = NWGetDefaultConnectionID(&conn);
	cnt += sprintf(string+cnt, "NWGetDefaultConnectionID returned:  %X\n", ccode);

	ccode = NWGetConnectionNumber (conn, &i);
	cnt += sprintf(string+cnt, "NWGetConnectNumber returned:  %X\n", ccode);

	memset( &addr, 0, sizeof( addr ) );
	ccode = NWGetInetAddr (conn, i, &addr);
	cnt += sprintf(string+cnt, "NWGetInetAddr returned:  %X\n", ccode);

	cnt += sprintf(string+cnt,
				"\nMy Address is: %02X%02X%02X%02X:%02X%02X%02X%02X%02X%02X:%04X\n",
	addr.networkAddr[0], addr.networkAddr[1],
	addr.networkAddr[2], addr.networkAddr[3],
	addr.netNodeAddr[0], addr.netNodeAddr[1],
	addr.netNodeAddr[2], addr.netNodeAddr[3],
	addr.netNodeAddr[4], addr.netNodeAddr[5],
	addr.socket);


	MBox(hwnd, (LPSTR)string, (LPSTR)"", MB_ICONINFORMATION);


	memcpy(destination.network, addr.networkAddr, 4);
	memcpy(destination.node, addr.netNodeAddr, 6);
	diagSocket=0x456;
	memcpy(destination.socket, &diagSocket, 2);

	ccode = BeginDiagnostics(&destination,&connectionID,	componentList);
	cnt = sprintf(string, "BeginDiagnostics returned:  %X\n", ccode);
	cnt += sprintf(string+cnt, "ComponentList = (" );
	for (idx=0 ; idx < componentList[0] + 1 ; idx++ ) {
	cnt += sprintf(string+cnt," %d", componentList[idx] );
	}
	cnt += sprintf(string+cnt, ")\n" );

	offset = (BYTE) FindComponentOffset(componentList, 2);
	cnt += sprintf(string+cnt,
	"FindComponentOffset( componentList, 2 ) returned:  %X\n",
	(WORD) offset);

	memset( &SHELLdata, 0, sizeof( SHELLdata ) );
	ccode =  GetShellDriverConfiguration(connectionID, offset, &intvptr, &SHELLdata);
	cnt += sprintf(string+cnt, "GetShellDriverConfiguration (2) returned:  %X\n", ccode);


	MBox(hwnd, (LPSTR)string, (LPSTR)"", MB_ICONINFORMATION);


	cnt = sprintf(string,
				"Network Address From Shell: %02X%02X%02X%02X\n",
	SHELLdata.networkAddress[0],SHELLdata.networkAddress[1],
	SHELLdata.networkAddress[2],SHELLdata.networkAddress[3]);

	cnt += sprintf(string+cnt,
				"Node Address From Shell: %02X%02X%02X%02X%02X%02X\n",
	SHELLdata.nodeAddress[0],SHELLdata.nodeAddress[1],
	SHELLdata.nodeAddress[2],SHELLdata.nodeAddress[3],
	SHELLdata.nodeAddress[4],SHELLdata.nodeAddress[5]);

	cnt += sprintf(string+cnt,"Node Address: %02X\n",
	SHELLdata.LANMode,SHELLdata.nodeAddressType);

	cnt += sprintf(string+cnt,"Resevered1: %02X\n",
	SHELLdata.maxDataSize,SHELLdata.reserved1);

	cnt += sprintf(string+cnt,
		 "Time: %u\n",
		 SHELLdata.transportTime);

	cnt += sprintf(string+cnt,
			 "Reserved2: %s\nMajor Version, %u\n",
	 SHELLdata.reserved2,SHELLdata.majorVersion);

	MBox(hwnd, (LPSTR)string, (LPSTR)"", MB_ICONINFORMATION);
	cnt = sprintf(string, "Reserved2: (" );
	for (idx=0 ; idx < 11 ; idx++ ) {
	cnt += sprintf(string+cnt," %d", (SHELLdata.reserved2)[idx] );
	}
	cnt += sprintf(string+cnt, ")\n" );

	cnt += sprintf(string+cnt,
			 "Major Version, %u\nMinor Version, %u\n",
	 SHELLdata.majorVersion,SHELLdata.minorVersion);

	cnt += sprintf(string+cnt,
	"Ethernet Flag Bits, %u\n",
	SHELLdata.ethernetFlagBits);

	cnt += sprintf(string+cnt,
				"Selected Configuration, %X\nLAN Description: [%s]\n",
	SHELLdata.selectedConfiguration,SHELLdata.LANDescription);

	cnt += sprintf(string+cnt,
				"IOAddress1: %02X    IODecode Range1: %X\n",
	SHELLdata.IOAddress1,SHELLdata.IODecodeRange1);

	cnt += sprintf(string+cnt,
				"IOAddress2: %02X    IODecodeRange2: %X\n",
	SHELLdata.IOAddress2,SHELLdata.IODecodeRange2);
	MBox(hwnd, (LPSTR)string, (LPSTR)"", MB_ICONINFORMATION);

	cnt = sprintf(string,
				"Memory Address1: %02X%02X:%02X     Memory Decode Range1: %04X\n",
	SHELLdata.memoryAddress1[2],
	SHELLdata.memoryAddress1[1],
	SHELLdata.memoryAddress1[0],SHELLdata.memoryDecodeRange1);

	cnt += sprintf(string+cnt,
				"Memory Address2: %02X%02X:%02X    Memory Decode Range2: %04X\n",
	SHELLdata.memoryAddress2[2],
	SHELLdata.memoryAddress2[1],
	SHELLdata.memoryAddress2[0],SHELLdata.memoryDecodeRange2);
	MBox(hwnd, (LPSTR)string, (LPSTR)"", MB_ICONINFORMATION);

	cnt = sprintf(string,
				"Interrupt Is Used1: %X    Interrupt Line1: %u\n",
	SHELLdata.interruptIsUsed1,SHELLdata.interruptLine1);

	cnt += sprintf(string+cnt,
				"Interrupt Is Used2: %X    Interrupt Line2: %u\n",
	SHELLdata.interruptIsUsed2,SHELLdata.interruptLine2);

	cnt += sprintf(string+cnt,
				"DMA Is Used1: %X    DMA Line1: %u\n",
	SHELLdata.DMAIsUsed1,SHELLdata.DMALine1);
	MBox(hwnd, (LPSTR)string, (LPSTR)"", MB_ICONINFORMATION);

	cnt = sprintf(string,
				"DMA Is Used2: %X    DMA Line2: %u\n",
	SHELLdata.DMAIsUsed2,SHELLdata.DMALine2);

	cnt += sprintf(string+cnt,
				"Config Description:\n[%s]\n",
	SHELLdata.textDescription);
	MBox(hwnd, (LPSTR)string, (LPSTR)"", MB_ICONINFORMATION);
	//---------------------------------------------------------

	EndDiagnostics(connectionID);

	return;
}
